using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

namespace ConstraintsUnique
{
    class Program
    {
        static void Main(string[] args)
        {
            DataTable dtOsoba = new DataTable("Osoba");
            dtOsoba.Columns.Add(new DataColumn("ID", Type.GetType("System.Int32")));
            dtOsoba.Columns.Add(new DataColumn("Imie", Type.GetType("System.String")));
            dtOsoba.Columns.Add(new DataColumn("Nazwisko", Type.GetType("System.String")));
            dtOsoba.Columns.Add(new DataColumn("DataUrodzenia", Type.GetType("System.DateTime")));
            dtOsoba.Columns.Add(new DataColumn("Telefon", Type.GetType("System.String")));

            dtOsoba.Columns["Telefon"].Unique = true;
            dtOsoba.Columns["Telefon"].AllowDBNull = false;

            dtOsoba.PrimaryKey = new DataColumn[] { dtOsoba.Columns["ID"] };
            dtOsoba.Columns["ID"].AutoIncrement = true;
            dtOsoba.Columns["ID"].AutoIncrementSeed = 1;
            dtOsoba.Columns["ID"].AutoIncrementStep = 1;

            UniqueConstraint dtOsobaMultiConstraint = new UniqueConstraint(new DataColumn[] { 
                dtOsoba.Columns["Imie"], dtOsoba.Columns["Nazwisko"], dtOsoba.Columns["DataUrodzenia"] });
            dtOsoba.Constraints.Add(dtOsobaMultiConstraint);

            dtOsoba.Rows.Add(1, "Jan", "Kowalski", "1989-12-12", "071-345-14-14");
            dtOsoba.Rows.Add(2, "Jan", "Kowalski", "1989-12-13", "071-345-14-15");
            dtOsoba.Rows.Add(3, "Jan", "Kowalski", "1989-12-14", "071-345-14-16");
            dtOsoba.Rows.Add(4, "Jan", "Kowalski", null, "071-345-14-17");

            Console.ReadLine();
        }
    }
}
