/*

Przykad na podstawie dokumentacji:
http://msdn2.microsoft.com/en-us/library/system.data.datarowstate(vs.80).aspx 

 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace DataAdapterUpdates
{
    class Program
    {
        private void DemonstrateRowState()
        {
            //Run a function to create a DataTable with one column.
            DataTable myTable = MakeTable();
            DataRow myRow;

            // Create a new DataRow.
            myRow = myTable.NewRow();
            // Detached row.
            Console.WriteLine("New Row " + myRow.RowState);

            myTable.Rows.Add(myRow);
            // New row.
            Console.WriteLine("AddRow " + myRow.RowState);

            myTable.AcceptChanges();
            // Unchanged row.
            Console.WriteLine("AcceptChanges " + myRow.RowState);

            myRow["FirstName"] = "Scott";
            // Modified row.
            Console.WriteLine("Modified " + myRow.RowState);

            myRow.Delete();
            // Deleted row.
            Console.WriteLine("Deleted " + myRow.RowState);

            myTable.AcceptChanges(); // drugi raz bez tej instrukcji
            
            myTable.Rows.Add(myRow);
            // New row.
            Console.WriteLine("AddRow " + myRow.RowState);
        
        }

        private DataTable MakeTable()
        {
            // Make a simple table with one column.
            DataTable dt = new DataTable("myTable");
            DataColumn dcFirstName = new DataColumn("FirstName", Type.GetType("System.String"));
            dt.Columns.Add(dcFirstName);
            return dt;
        }        
        
        static void Main(string[] args)
        {
            Program p = new Program();
            p.DemonstrateRowState();
        }
    }
}
