using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace DataAdapterUpdates3
{
    class Program
    {
        private static void PrintDataTable(DataTable dt)
        {
            foreach (DataRow r in dt.Rows)
            {
                foreach (DataColumn c in dt.Columns)
                {
                    if (r.RowState != DataRowState.Deleted)
                        Console.Write(r[c] + "\t");
                }
                Console.WriteLine(r.RowState);
            }
            Console.WriteLine();
        }

        static void Main(string[] args)
        {
            SqlConnection connection = new SqlConnection("Data Source=.; Initial Catalog=Test; Integrated Security=true;");
            SqlDataAdapter da = new SqlDataAdapter();
            da.SelectCommand = new SqlCommand("SELECT ID, Imie, Nazwisko, Pensja FROM Osoba", connection);
            da.InsertCommand = new SqlCommand("INSERT INTO Osoba (ID, Imie, Nazwisko, Pensja) VALUES(@ID, @Imie, @Nazwisko, @Pensja)", connection);
            da.UpdateCommand = new SqlCommand("UPDATE Osoba SET ID=@ID, Imie=@Imie, Nazwisko=@Nazwisko, Pensja=@Pensja WHERE ID=@ID_prev", connection);
            da.DeleteCommand = new SqlCommand("DELETE FROM Osoba WHERE ID=@ID", connection);

            da.InsertCommand.Parameters.Add("@ID", SqlDbType.Int, 0, "ID").SourceVersion = DataRowVersion.Original;
            da.InsertCommand.Parameters.Add("@Imie", SqlDbType.VarChar, 30, "Imie").SourceVersion = DataRowVersion.Original;
            da.InsertCommand.Parameters.Add("@Nazwisko", SqlDbType.VarChar, 50, "Nazwisko").SourceVersion = DataRowVersion.Original;
            da.InsertCommand.Parameters.Add("@Pensja", SqlDbType.Int, 0, "Pensja").SourceVersion = DataRowVersion.Original;

            da.UpdateCommand.Parameters.Add("@ID", SqlDbType.Int, 0, "ID").SourceVersion = DataRowVersion.Current;
            da.UpdateCommand.Parameters.Add("@Imie", SqlDbType.VarChar, 30, "Imie").SourceVersion = DataRowVersion.Current;
            da.UpdateCommand.Parameters.Add("@Nazwisko", SqlDbType.VarChar, 50, "Nazwisko").SourceVersion = DataRowVersion.Current;
            da.UpdateCommand.Parameters.Add("@Pensja", SqlDbType.Int, 0, "Pensja").SourceVersion = DataRowVersion.Current;
            da.UpdateCommand.Parameters.Add("@ID_Prev", SqlDbType.Int, 0, "ID").SourceVersion = DataRowVersion.Original;

            da.DeleteCommand.Parameters.Add("@ID", SqlDbType.Int, 0, "ID").SourceVersion = DataRowVersion.Current;

            da.RowUpdating += new SqlRowUpdatingEventHandler(da_RowUpdating);

            DataTable dt = new DataTable("Osoba");
            da.Fill(dt);
            foreach (DataRow r in dt.Rows)
            {
                if ( r["Pensja"].GetType() == typeof( System.DBNull ) )
                    continue;
                if ((int)(r["Pensja"]) < 1650)
                {
                    int x = (int)r["Pensja"];
                    x += 77;
                    r["Pensja"] = x;
                    int y = (int)r["ID"];
                    y += 1000;
                    r["ID"] = y;
                }
                else if ((int)(r["Pensja"]) >= 1900)
                {
                    r.Delete();
                }
                r.EndEdit();
            }
            DataRow newRow = dt.NewRow();
            newRow["ID"] = 666;
            newRow["Imie"] = "Johnny";
            newRow["Nazwisko"] = "Szpinak";
            dt.Rows.Add(newRow);

            DataTable dtChanges = dt.GetChanges();
            Console.WriteLine("Tabela ze zmianami:");
            PrintDataTable(dtChanges);

            if (dtChanges != null)
            {
                da.Update(dtChanges);
                dt.AcceptChanges();
            }

            Console.WriteLine("Tabela po zmianach:");
            PrintDataTable(dt);

            Console.ReadLine();
        }

        static void da_RowUpdating(object sender, SqlRowUpdatingEventArgs e)
        {
            Console.WriteLine("------------");
            Console.WriteLine("Command: " + e.Command.CommandText);
            Console.Write("Parameters: ");
            foreach (SqlParameter p in e.Command.Parameters)
            {
                Console.Write(p.Value+"("+p.SourceVersion+")"+", ");
            }
            Console.WriteLine();
            if (e.Row.RowState != DataRowState.Deleted)
            {
                Console.Write("Row: ");
                foreach (object o in e.Row.ItemArray)
                {
                    Console.Write(o.ToString() + ", ");
                }
                Console.WriteLine();
            }
            Console.WriteLine("StatementType: " + e.StatementType);
            Console.WriteLine("Status: " + e.Status);
            Console.WriteLine("------------");
        }
    }
}
