/* 
 * 
 * Przykad na podstawie: Bipin Joshi, et al., Professional ADO.NET Programming, Wrox
 * 
 */


/* Przygotowanie bazy danych

drop table Osoba;
go

create table Osoba(
  ID int not null primary key identity,
  Imie varchar(30) default 'Jan',
  Nazwisko varchar(50) default 'Kowalski',
);
go

begin
  delete from Osoba;
  insert into Osoba values( 'Jan', 'Kowalski' );
  insert into Osoba values( 'Ewa', 'Solska' );
  insert into Osoba values( 'Boydar', 'Nowak' );
  insert into Osoba values( 'Adam', 'Adamski' );
  insert into Osoba values( 'Zygmunt', 'Riposta' );
  insert into Osoba values( 'Alicja', 'Gleba' );
  insert into Osoba values( 'Tania', 'Borwka' );
  insert into Osoba values( 'Natasza', 'Lizacka' );
  insert into Osoba values( 'Stan', 'Taczkowski' );
end;
go

*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace TransactionsIsolationLevel
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection connection1, connection2;
            SqlCommand command1, command2;
            SqlTransaction transaction1, transaction2;
            SqlDataReader reader;
            string ConnectionString = "Data Source=.; Initial Catalog=Test; Integrated Security=true";
            connection1 = new SqlConnection(ConnectionString);
            connection2 = new SqlConnection(ConnectionString);
            connection1.Open();
            connection2.Open();

            transaction1 = connection1.BeginTransaction();
            transaction2 = connection2.BeginTransaction( IsolationLevel.ReadUncommitted );
            // Ustawienie poniszego sprawi, e odczyt danych (wiersz 76 si zawiesi)
            //transaction2 = connection2.BeginTransaction( IsolationLevel.Serializable );
            command1 = new SqlCommand();
            command1.Connection = connection1;
            command1.Transaction = transaction1;

            command2 = new SqlCommand();
            command2.Connection = connection2;
            command2.Transaction = transaction2;
            try
            {
                command1.CommandText = "INSERT INTO Osoba DEFAULT VALUES";
                command1.ExecuteNonQuery();
                command1.CommandText = "INSERT INTO Osoba DEFAULT VALUES";
                command1.ExecuteNonQuery();
                command2.CommandText = "SELECT TOP 2 ID FROM Osoba ORDER BY ID DESC";
                reader = command2.ExecuteReader(); // (wiersz 76)
                Console.WriteLine("Ostatnie dwie osoby - w trakcie transakcji");
                while (reader.Read())
                {
                    Console.WriteLine(reader.GetInt32(0));
                }
                reader.Close();
                Console.ReadLine();
                transaction1.Rollback();
                command2.CommandText = "SELECT TOP 2 ID FROM Osoba ORDER BY ID DESC";
                reader = command2.ExecuteReader();
                Console.WriteLine("Ostatnie dwie osoby - transakcja wycofana");
                while (reader.Read())
                {
                    Console.WriteLine(reader.GetInt32(0));
                }
                Console.ReadLine();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                Console.ReadLine();
            }
            finally
            {
                connection1.Close();
                connection2.Close();
            }
        }
    }
}
